<?php

/** Configuration file for Omniture/Twitter Integration.  Configure before script execution. */
require('omtrTwitConfig.php');


/** most recent tweet id is stored in twitid.txt; used to grab only new tweets since last script execution */
$twitIdFile = "twitid.txt";
$fh = fopen($twitIdFile, 'r');
$twitSinceId = fread($fh, filesize($twitIdFile));
fclose($fh);
$s=$twitSinceId;


/** call Twitter Search API.  Required Parameters: 
$rpp=max search results to return.  defined in omtrTwitConfig.php
$since_id=id of last tweet processed.  returned from twitid.txt
$q=search terms.  defined in omtrTwitConfig.php
*/


// Format Multiple Search Terms
$multiSearch = explode(",",$q);
$numTerms=count($multiSearch);

$k=0;

while ($k<$numTerms)
{
$ors .= '"'. $multiSearch[$k] . '"';

$k++;
 
 if ($k < $numTerms){
 	$ors .= " ";
 }
 
}

$ors = urlencode($ors);

$search = "http://search.twitter.com/search.atom?rpp=".$rpp."&since_id=".$s."&ors=".$ors."";

//echo $search;
//echo "<br>";


/* connect to Twitter Search API and process results using SimpleXMLElement
REQUIRES: PHP5
*/
$tw = curl_init();

curl_setopt($tw, CURLOPT_URL, $search);
curl_setopt($tw, CURLOPT_RETURNTRANSFER, TRUE);
$twi = curl_exec($tw);
$search_res = new SimpleXMLElement($twi);


/* script runs as a CRON job but results are printed out for testing purposes.  results can also be emailed from CRON job. */
echo "<h3>Twitter search results for '".$ors."'</h3>";

$i=0;

/* step through Twitter results */
foreach ($search_res->entry as $twit1) {
	echo $i;
	echo $twit1->content;
	echo "<br>";
	echo $twit1->id;
	echo "<br>";
	echo $twit1->author->name;
	echo "<br>";
	$twit_id = explode(":", $twit1->id);
	echo $twit_id[2];
	$wTwitId=$twit_id[2];
	echo "<br><br>";

		/* if tweet is the most recent tweet, grab id and write to twitid.txt.  */ 	
		if ($i==0) {
  			$fh = fopen($twitIdFile, 'w') or die("can't open file");
  			$stringData = $wTwitId;
			fwrite($fh, $stringData);
			fclose($fh);	
		}


//capture twitter values for insertion
$tweetAuthor = strip_tags($twit1->author->name);
$tweetContent = strip_tags($twit1->content);  //HTML tags must be stripped from the content or they will fail to be loaded into Omniture variables


/* connect to Twitter User API to get # of followers and process results using SimpleXMLElement
REQUIRES: PHP5
*/
$twUser = curl_init();

$findUser = "http://twitter.com/users/show.xml?screen_name=".$tweetAuthor;

curl_setopt($twUser, CURLOPT_URL, $findUser);
curl_setopt($twUser, CURLOPT_RETURNTRANSFER, TRUE);
$twiUser = curl_exec($twUser);
$twitterUser = new SimpleXMLElement($twiUser);

$numFollowers = $twitterUser->followers_count;
echo "FOLLOWERS:".$numFollowers;


// create opening XML tags
$xml  = "<?xml version=1.0 encoding=UTF-8?>\n";
$xml .= "<request>\n";
$xml .= " <scXmlVer>1.0</scXmlVer>\n"; 

// add tags for required elements
$xml .= $rsid ? " <reportSuiteID>$rsid</reportSuiteID>\n":""; 

$xml .= $vid ? " <visitorID>$vid</visitorID>\n":"";
$xml .= $ip ? " <ipAddress>$ip</ipAddress>\n":""; 

$xml .= $page_url ? " <pageURL>$page_url</pageURL>\n":"";
$xml .= $pageName ? " <pageName>$pageName</pageName>\n":""; 

/* conversion event tracking */
$xml .= $successEvent ? " <events>$successEvent</events>\n":"";

	/* [OPTIONAL] conversion tracking */
	/* eVar tweet author */
	if ($eTweetAuthor != ""){
		$xml .= $tweetAuthor ? " <$eTweetAuthor>$tweetAuthor</$eTweetAuthor>\n":"";
	}

	/* eVar tweet content */
	if ($eTweetContent != ""){
		$xml .= $tweetContent ? " <$eTweetContent>$tweetContent</$eTweetContent>\n":"";
	}

	/* eVar twitter search */
	if ($eTweetSearch != ""){
		$xml .= $q ? " <$eTweetSearch>$q</$eTweetSearch>\n":"";
	}
	
	/* eVar twitter keyword group */
	if ($eTweetGroup != ""){
		$xml .= $keywordGroup ? " <$eTweetGroup>$keywordGroup</$eTweetGroup>\n":"";
	}

	/* eVar twitter # of followers */
	if ($eTweetFollowers != ""){
		$xml .= $numFollowers ? " <$eTweetFollowers>$numFollowers</$eTweetFollowers>\n":"";
	}

/* custom insight tracking [OPTIONAL] */
	if ($pTweetAuthor != ""){
		$xml .= $tweetAuthor ? " <$pTweetAuthor>$tweetAuthor</$pTweetAuthor>\n":"";
	}

	/* prop tweet content */
	if ($pTweetContent != ""){
		$xml .= $tweetContent ? " <$pTweetContent>$tweetContent</$pTweetContent>\n":"";
	}

	/* prop twitter search */
	if ($pTweetSearch != ""){
		$xml .= $q ? " <$pTweetSearch>$q</$pTweetSearch>\n":"";
	}

	/* prop twitter keyword group */
	if ($pTweetGroup != ""){
		$xml .= $keywordGroup ? " <$pTweetGroup>$keywordGroup</$pTweetGroup>\n":"";
	}
	
	/* prop twitter keyword group */
	if ($pTweetFollowers != ""){
		$xml .= $numFollowers ? " <$pTweetFollowers>$numFollowers</$pTweetFollowers>\n":"";
	}

// close the XML request
$xml .= "</request>\n"; 

echo $xml;

// Create POST, Host and Content-Length headers
$head = "POST /b/ss//6 HTTP/1.0\n";
$head .= "Host: $host\n";
$head .= "Content-Length: ".(string)strlen($xml)."\n\n"; 

// combine the head and XML
$request = $head.$xml; 

$fp=fsockopen($host,80,$errno,$errstr,30); 
// Use this function in place of the call above if you have PHP 4.3.0 or
//   higher and have compiled OpenSSL into the build.
//
// $fp = pfsockopen("ssl://".$host, 443, $errno, $errstr);
// 
if( $fp ) { 

// send data
fwrite($fp,$request); 

// get response
$response="";
while( !feof($fp) ){
	$response .= fgets($fp,1028);
}
fclose($fp); 

// display results
echo "RESULTS:\n";
print_r($response);
echo "\n"; 

// check for errors
if( preg_match("/status\>FAILURE\<\/status/im",$response) ){
	/*
	* TODO:
	* write $request and $response to log file for investigation
	* and retries
	*/
	echo "<h1>Failure</h1>\n";
	echo "<p>Note the reason tag in the response, fix and try again.</h1>\n";
}
} else {
echo "<H1>Couldn't open port to SiteCatalyst servers</H1>\n"; 
if(!$rsid){
	echo "<H4>No report suite specified</H4>\n";
} else {
	echo "<p>$errstr ($errno)</p>\n";
	/*
	* TODO:
	* write $request and $errstr to log file for investigation
	* and retries
	*/
}
}
//END OMNITURE DATA INSERTION API CODE BLOCK

$i++;
}


curl_close($tw);

?>
